local e=require("luci.model.uci").cursor()
local p=require("luci.tools.webadmin")
local c=require("nixio.fs")
local u=require("luci.ip")
local i=e:get("nft-qos","default","static_rate_dl")
local t=e:get("nft-qos","default","static_rate_ul")
local a=e:get("nft-qos","default","static_unit_dl")
local n=e:get("nft-qos","default","static_unit_ul")
local f=e:get("nft-qos","default","dynamic_bw_up")
local w=e:get("nft-qos","default","dynamic_bw_down")
local h=e:get("nft-qos","default","limit_enable")
local d=e:get("nft-qos","default","limit_mac_enable")
local l=e:get("nft-qos","default","limit_type")
local r=e:get("nft-qos","default","priority_enable")
local e=c.access("/proc/net/ipv6_route")
m=Map("nft-qos",translate("QoS over Nftables"))
s=m:section(TypedSection,"default",translate("NFT-QoS Settings"))
s.addremove=false
s.anonymous=true
s:tab("limit",translate("Limit Rate by IP Address"))
s:tab("limitmac",translate("Limit Rate by Mac Address"))
s:tab("priority",translate("Traffic Priority"))
o=s:taboption("limit",Flag,"limit_enable",translate("Limit Enable"),translate("Enable Limit Rate Feature"))
o.default=h or o.enabled
o.rmempty=false
o=s:taboption("limit",ListValue,"limit_type",translate("Limit Type"),translate("Type of Limit Rate"))
o.default=limit_static or"static"
o:depends("limit_enable","1")
o:value("static","Static")
o:value("dynamic","Dynamic")
o=s:taboption("limit",Value,"static_rate_dl",translate("Default Download Rate"),translate("Default value for download rate"))
o.datatype="uinteger"
o.default=i or'50'
o:depends("limit_type","static")
o=s:taboption("limit",ListValue,"static_unit_dl",translate("Default Download Unit"),translate("Default unit for download rate"))
o.default=a or"kbytes"
o:depends("limit_type","static")
o:value("bytes","Bytes/s")
o:value("kbytes","KBytes/s")
o:value("mbytes","MBytes/s")
o=s:taboption("limit",Value,"static_rate_ul",translate("Default Upload Rate"),translate("Default value for upload rate"))
o.datatype="uinteger"
o.default=t or'50'
o:depends("limit_type","static")
o=s:taboption("limit",ListValue,"static_unit_ul",translate("Default Upload Unit"),translate("Default unit for upload rate"))
o.default=n or"kbytes"
o:depends("limit_type","static")
o:value("bytes","Bytes/s")
o:value("kbytes","KBytes/s")
o:value("mbytes","MBytes/s")
o=s:taboption("limit",Value,"dynamic_bw_down",translate("Download Bandwidth (Mbps)"),translate("Default value for download bandwidth"))
o.default=f or'100'
o.datatype="uinteger"
o:depends("limit_type","dynamic")
o=s:taboption("limit",Value,"dynamic_bw_up",translate("Upload Bandwidth (Mbps)"),translate("Default value for upload bandwidth"))
o.default=w or'100'
o.datatype="uinteger"
o:depends("limit_type","dynamic")
o=s:taboption("limit",Value,"dynamic_cidr",translate("Target Network (IPv4/MASK)"),translate("Network to be applied, e.g. 192.168.1.0/24, 10.2.0.0/16, etc."))
o.datatype="cidr4"
u.routes({family=4,type=1},function(e)o.default=e.dest end)
o:depends("limit_type","dynamic")
if e then
o=s:taboption("limit",Value,"dynamic_cidr6",translate("Target Network6 (IPv6/MASK)"),translate("Network to be applied, e.g. AAAA::BBBB/64, CCCC::1/128, etc."))
o.datatype="cidr6"
o:depends("limit_type","dynamic")
end
o=s:taboption("limit",DynamicList,"limit_whitelist",translate("White List for Limit Rate"))
o.datatype="ipaddr"
o:depends("limit_enable","1")
o=s:taboption("limitmac",Flag,"limit_mac_enable",translate("Limit Enable"),translate("Enable Limit Rate Feature"))
o.default=d or o.enabled
o.rmempty=false
o=s:taboption("priority",Flag,"priority_enable",translate("Enable Traffic Priority"),translate("Enable this feature"))
o.default=r or o.enabled
o.rmempty=false
o=s:taboption("priority",ListValue,"priority_netdev",translate("Default Network Interface"),translate("Network Interface for Traffic Shaping, e.g. br-lan, eth0.1, eth0, etc."))
o:depends("priority_enable","1")
p.cbi_add_networks(o)
if h=="1"and l=="static"then
x=m:section(TypedSection,"download",translate("Static QoS-Download Rate"))
x.anonymous=true
x.addremove=true
x.template="cbi/tblsection"
o=x:option(Value,"hostname",translate("Hostname"))
o.datatype="hostname"
o.default='undefined'
if e then
o=x:option(Value,"ipaddr",translate("IP Address (v4 / v6)"))
else
o=x:option(Value,"ipaddr",translate("IP Address (v4 Only)"))
end
o.datatype="ipaddr"
if nixio.fs.access("/tmp/dhcp.leases")or nixio.fs.access("/var/dhcp6.leases")then
o.titleref=luci.dispatcher.build_url("admin","status","overview")
end
o=x:option(Value,"rate",translate("Rate"))
o.default=i or'50'
o.size=4
o.datatype="uinteger"
o=x:option(ListValue,"unit",translate("Unit"))
o.default=a or"kbytes"
o:value("bytes","Bytes/s")
o:value("kbytes","KBytes/s")
o:value("mbytes","MBytes/s")
y=m:section(TypedSection,"upload",translate("Static QoS-Upload Rate"))
y.anonymous=true
y.addremove=true
y.template="cbi/tblsection"
o=y:option(Value,"hostname",translate("Hostname"))
o.datatype="hostname"
o.default='undefined'
if e then
o=y:option(Value,"ipaddr",translate("IP Address (v4 / v6)"))
else
o=y:option(Value,"ipaddr",translate("IP Address (v4 Only)"))
end
o.datatype="ipaddr"
if nixio.fs.access("/tmp/dhcp.leases")or nixio.fs.access("/var/dhcp6.leases")then
o.titleref=luci.dispatcher.build_url("admin","status","overview")
end
o=y:option(Value,"rate",translate("Rate"))
o.default=t or'50'
o.size=4
o.datatype="uinteger"
o=y:option(ListValue,"unit",translate("Unit"))
o.default=n or"kbytes"
o:value("bytes","Bytes/s")
o:value("kbytes","KBytes/s")
o:value("mbytes","MBytes/s")
end
if r=="1"then
s=m:section(TypedSection,"priority",translate("Traffic Priority Settings"))
s.anonymous=true
s.addremove=true
s.template="cbi/tblsection"
o=s:option(ListValue,"protocol",translate("Protocol"))
o.default="tcp"
o:value("tcp","TCP")
o:value("udp","UDP")
o:value("udplite","UDP-Lite")
o:value("sctp","SCTP")
o:value("dccp","DCCP")
o=s:option(ListValue,"priority",translate("Priority"))
o.default="1"
o:value("-400","1")
o:value("-300","2")
o:value("-225","3")
o:value("-200","4")
o:value("-150","5")
o:value("-100","6")
o:value("0","7")
o:value("50","8")
o:value("100","9")
o:value("225","10")
o:value("300","11")
o=s:option(Value,"service",translate("Service"),translate("e.g. https, 23, (separator is comma)"))
o.default='?'
o=s:option(Value,"comment",translate("Comment"))
o.default='?'
end
if d=="1"then
x=m:section(TypedSection,"client",translate("Limit Traffic Rate By Mac Address"))
x.anonymous=true
x.addremove=true
x.template="cbi/tblsection"
o=x:option(Value,"hostname",translate("Hostname"))
o.datatype="hostname"
o.default=''
o=x:option(Value,"macaddr",translate("MAC Address"))
o.rmempty=true
o.datatype="macaddr"
o=x:option(Value,"drate",translate("Download Rate"))
o.default=i or'50'
o.size=4
o.datatype="uinteger"
o=x:option(ListValue,"drunit",translate("Unit"))
o.default=a or"kbytes"
o:value("bytes","Bytes/s")
o:value("kbytes","KBytes/s")
o:value("mbytes","MBytes/s")
o=x:option(Value,"urate",translate("Upload Rate"))
o.default=t or'50'
o.size=4
o.datatype="uinteger"
o=x:option(ListValue,"urunit",translate("Unit"))
o.default=n or"kbytes"
o:value("bytes","Bytes/s")
o:value("kbytes","KBytes/s")
o:value("mbytes","MBytes/s")
end
return m
